package route

import (
	"kpt-pasture/http/handler/event"

	"github.com/gin-gonic/gin"
)

func EventAPI(opts ...func(engine *gin.Engine)) func(s *gin.Engine) {
	return func(s *gin.Engine) {
		for _, opt := range opts {
			opt(s)
		}
		// eventRoute API 组  事件管理
		eventRoute := authRouteGroup(s, "/api/v1/event/")
		eventRoute.POST("/enter/list", event.EnterEventList)
		eventRoute.POST("/enter/create", event.EnterEventCreate)

		eventRoute.POST("/group/transfer/list", event.GroupTransferEventList)
		eventRoute.POST("/group/transfer/create", event.GroupTransferEventCreate)

		eventRoute.POST("/body/score/list", event.BodyScoreEventList)
	}
}
